
close all
clear all

ROIcoords = [102 179 91 122];
newangle = 59.42;
midpointx = 107;
midpointy = 141;
Imagesize = [434 256];


numrow = (ROIcoords(2))-ROIcoords(1)+1;
numcol = (ROIcoords(4))-ROIcoords(3)+1;


% Activation Energy fitting

% Interactively allows the selection of a line to generate and ROI and give
% EA profile. Outputs to text files.

% Richard Foster

% Created 2017

% Calls the following script files: rotateAround
% Calls the following function files: 



%% Define initial default search path for data
path_name = 'M:\New Cartilage Project' ;

%% Determine number of T1 images to analyse

numfiles = input ('Number of T1 images to analyse for EA: ');

temperatures = zeros(1,numfiles);

f=1;

% %% Take first image and determine ROI from it
% 
% temp = input ('Temperature at which T1 image obtained (in degC): ');
% temperatures(f) = temp;
% 
% [filename, path_name] = uigetfile(path_name,'Select Image');
% if isequal(filename,0);
%     break
% end
% Loaddatafilename = strcat(path_name, filename);
% Loaddata = load(Loaddatafilename);
% path_name = strcat(path_name, '*.*');
% Image = struct2cell(Loaddata);
% DispImage1 = Image{1};
% 
% Relaxationdata = DispImage1(:,:,1);
% M0data = DispImage1(:,:,2);
% r2data = DispImage1(:,:,3);
% M0err = DispImage1(:,:,4);
% relaxationerr = DispImage1(:,:,5);
% 
% Imagesize = [size(Relaxationdata,1) size(Relaxationdata,2)];
% 
% figure(1)
% clf
% set(1, 'Units','Pixels');
% imagesc(Relaxationdata,[0 5]); axis image; axis off
% ROIline = imline;
% stuff = getPosition(ROIline);
% stuff= round(stuff);
% 
% midpointx = ((stuff(2,1)-stuff(1,1))/2)+stuff(1,1);
% midpointx = floor(midpointx);
% midpointy = ((stuff(2,2)-stuff(1,2))/2)+stuff(1,2);
% midpointy = floor(midpointy);
% angle=atan((stuff(2,1)-stuff(1,1))/(stuff(2,2)-stuff(1,2)));
% newangle = rad2deg(angle);
% linelength = ((stuff(2,1)-stuff(1,1))/sin(angle));
% stupid = rotateAround(Relaxationdata,midpointy, midpointx, -newangle,'bicubic');
% figure(2)
% clf
% imagesc(stupid, [0 5]); axis off image;
% 
% h=rectangle('Position',[(midpointx-15) (midpointy-(linelength/2)) 30 linelength], 'LineWidth',3);
% 
% ROI = zeros(size(Relaxationdata));
% ROI((midpointy-(linelength/2)):(midpointy+(linelength/2)), (midpointx-15):(midpointx+15))=1;
% 
% ROIimage=ROI.*stupid;
% A = regionprops(ROI,'Boundingbox');
% b = floor(A(1).BoundingBox);
% T1data(:,:,f) = stupid(b(2):b(2)+b(4), b(1):b(1)+b(3));
% 
% 
% figure(4); clf;
% imagesc (T1data(:,:,f), [0 5]); axis off image;
% 
% numrow = (b(2)+b(4))-b(2)+1;
% numcol = (b(1)+b(3))-b(1)+1;
% 
% ROIcoords = [b(2) b(2)+b(4) b(1) b(1)+b(3)];
% 
% Errorrot = rotateAround(relaxationerr,midpointy,midpointx,-newangle,'bicubic');
% Errdata(:,:,f) = Errorrot(ROIcoords(1):ROIcoords(2), ROIcoords(3):ROIcoords(4));
% 
% 
% clear temp Image DispImage1 Relaxationdata M0data r2data M0err relaxationerr stupid Errorrot Loaddata Loaddatafilename filename
% 
for f = 1:numfiles
    
    temp = input ('Temperature at which T1 image obtained (in degC): ');
    temperatures(f) = temp;
    
    [filename, path_name] = uigetfile(path_name,'Select Image');
    if isequal(filename,0);
        break
    end
    Loaddatafilename = strcat(path_name, filename);
    Loaddata = load(Loaddatafilename);
    path_name = strcat(path_name, '*.*');
    Image = struct2cell(Loaddata);
    DispImage1 = Image{1};
    
    Relaxationdata = DispImage1(:,:,1);
    M0data = DispImage1(:,:,2);
    r2data = DispImage1(:,:,3);
    M0err = DispImage1(:,:,4);
    relaxationerr = DispImage1(:,:,5);
    
    stupid = rotateAround(Relaxationdata,midpointy, midpointx, -newangle,'bicubic');
    T1data(:,:,f) = stupid(ROIcoords(1):ROIcoords(2), ROIcoords(3):ROIcoords(4));
    Errorrot = rotateAround(relaxationerr,midpointy,midpointx,-newangle,'bicubic');
    Errdata(:,:,f) = Errorrot(ROIcoords(1):ROIcoords(2), ROIcoords(3):ROIcoords(4));
    
    
    clear temp Image DispImage1 Relaxationdata M0data r2data M0err relaxationerr stupid Errorrot Loaddata Loaddatafilename filename
    
end

for f=1:numfiles
    for i=1:numrow
        AveT1(i,f) = mean(T1data(i,:,f));
        Stderr(i,f) = std(T1data(i,:,f))/sqrt(numcol);
    end
end

LNT1=real(log(AveT1));
Errors = abs((Stderr./AveT1).*LNT1);
temperatures = temperatures+273.15;
RecipTemp = 1./temperatures;

for i=1:numrow
   
    ydata = LNT1(i,:);
    yerrors = Errors(i,:);
    [gradient, intercept, Graderr ,Interr] = linearfittingfn_w_stats (RecipTemp, ydata, yerrors);
    
    EA_fromaveT1(i,1) = -8.314472*gradient;
    EAerr_fromaveT1(i,1) = (Graderr/gradient).*(EA_fromaveT1(i,1));
    
    Prefactor_fromaveT1(i,1) = exp(intercept);
    Errpre_fromaveT1(i,1) = (Interr/intercept).*(Prefactor_fromaveT1(i,1));
    
    clear ydata yerrors gradient intercept Graderr Interr
    
end

EApx=zeros(size(AveT1(:,:,1)));
Errpx = zeros(size(AveT1(:,:,1)));

for i=1:numrow
   for j=1:numcol
      for k=1:numfiles
       ydata(:,k) = real(log(T1data(i,j,k)));
       yerrors(:,k) = abs((Errdata(i,j,k).*T1data(i,j,k)).*ydata(:,k));
      end
      yerrors(isinf(yerrors))=0;
      yerrors(isnan(yerrors))=0;
       [gradient, intercept, Graderr ,Interr] = linearfittingfn_w_stats (RecipTemp, ydata, yerrors);
       EApx(i,j) = -8.314472*gradient;
       Errpx(i,j) = (Graderr/gradient).*EApx(i,j);
       
       Prefactor_px(i,j) = exp(intercept);
       Errpre_px(i,j) = (Interr/intercept).*(Prefactor_fromaveT1(i,1));
       
       clear gradient intercept Graderr Interr ydata yerrors
   end
end
for i=1:numrow
EA_fromEApx(i,1) = mean(EApx(i,:));
EAerr_fromEApx(i,1) = std(EApx(i,:))./sqrt(numcol);

Prefactor_fromEApx(i,1) = mean(Prefactor_px(i,:));
Prefactorerr_fromEApx(i,1) = std(Prefactor_px(i,:))./sqrt(numcol);
end

%close(1)
%close(2)
%close(4)

pixelnos = zeros(numrow,1);
for i=1:numrow
   pixelnos(i) = i; 
end

%filestuff = strsplit(filename,'.');
pathstuff = strsplit(path_name,'*');

filestuff = input('Filename: ','s');
s=strcat(char(176),'C');
temperatures = round(temperatures-273.15);

filenameout = strcat(pathstuff{1},filestuff,'.txt');
fileID = fopen(filenameout, 'w');
fprintf(fileID, '%s \t %d %d %d %d \n','ROI coords [y1 y2 x1 x2]', ROIcoords);
fprintf(fileID,'%s \t %.2f\n', 'Angle rotated', newangle);
fprintf(fileID,'%s \t %s \t %d \t %s \t %d\n', 'point of rotation','midpointx',midpointx,'midpointy',midpointy);
fprintf(fileID, '%s \t %d %d\n','Image size(pixels)', Imagesize);
fprintf(fileID, '%s \t','Temperatures');
for i = 1:numfiles
   fprintf(fileID, '%d %s \t',temperatures(i),s);
end
fprintf(fileID, '\t\n');

fprintf(fileID, '%s \t', 'Pixelno');
for i=1:numfiles
    t = num2str(temperatures(i));
    fprintf(fileID, '%s %s %s \t %s %s %s \t', 'AveT1',t,s, 'T1err',t,s);
end
fprintf(fileID, '%s \t %s \t %s \t %s \t %s \t %s \t %s \t %s\n', 'EA (AveT1)','Err EA (Ave)','EA (pxbypx)','Err EA (pxbypx)', 'A (AveT1)','Aerr (AveT1)','A (pxbypx)','Aerr (px by px)');

fprintf(fileID, '%s \t',' ');
for i=1:numfiles
    fprintf(fileID, '%s \t %s \t', 's', 's');
end
fprintf(fileID, '%s \t %s \t %s \t %s\n', 'J/mol','J/mol','J/mol','J/mol');

%fprintf(fileID, '%s \t %s \t %s \t %s \t %s\n' , 'pixel','AveT1','T1error','Norm M0','M0 err');
for i=1:numrow;
    fprintf(fileID, '%d \t' ,  pixelnos(i));
    for j=1:numfiles
        fprintf(fileID, ' %.6f \t %.6f \t  ', AveT1(i,j), Errors(i,j));
    end
    fprintf(fileID, '%.6f \t  %.6f \t  %.6f \t %.6f \t %.6f \t %.6f \t %.6f \t %.6f\n', EA_fromaveT1(i), EAerr_fromaveT1(i), EA_fromEApx(i), EAerr_fromEApx(i),Prefactor_fromaveT1(i),Errpre_fromaveT1(i),Prefactor_fromEApx(i),Prefactorerr_fromEApx(i));
end
fclose(fileID);



