function data = extract_Bruker_data(Variable,array_type,array_size,filename,format)

%Author Robin Damion 2017

% Parameter extraction of Bruker text files

% Variable='PVM_DwDir';
% array_type='yes';
% array_size=[20,3];
% filename='method.txt';
% format='%f';

if nargin==4
    format='%f';
end

prefix='##$';
searchTerm=strcat(prefix,Variable);
[dummy searchTermSize]=size(searchTerm);
%disp(searchTermSize);
fid=fopen(filename);
f=fscanf(fid,'%c'); 
[m n]=size(f);

  
index=strfind(f,searchTerm);
occurence=1;
search_again=1;
while (search_again==1)
    search_again=0;
    ind=index(occurence);
    %disp(['ind=',num2str(ind)]);
    if ind>0
        %disp(['index=',num2str(index)]);
        %% Normal array
        if strcmp(array_type,'yes')==1 || strcmp(array_type,'YES')==1 || strcmp(array_type,'Yes')==1
            k=1;
            while (f(ind+k)~=')') 
                k=k+1;  
            end
            if (k-searchTermSize)>20
                occurence=occurence+1;
                search_again=1; 
            end
            %disp(k);
            %disp(search_again);
            if search_again==0
                ind=ind+k+1;
                %disp(f(ind:ind+50));
                f(1:ind-1)=[];
                data=sscanf(f,format,array_size);
                %disp(data);
            else
                %break;
            end
        %% Usually single value after equal sign
        elseif strcmp(array_type,'no')==1 || strcmp(array_type,'NO')==1 || strcmp(array_type,'No')==1
            k=1;
            while (f(ind+k)~='=') 
                k=k+1;  
            end
            if (k-searchTermSize)>1
                occurence=occurence+1;
                search_again=1; 
            end
            %disp(k);
            %disp(search_again);
            if search_again==0
                ind=ind+k+1;
                %disp(f(ind:ind+50));
                f(1:ind-1)=[];
                data=sscanf(f,format,array_size);
                %disp(data);
            else
                %break;
            end
        %% Special format for Rf pulse paramters; values comma-separated in parentheses
        elseif strcmp(array_type,'rf')==1 || strcmp(array_type,'RF')==1 || strcmp(array_type,'Rf')==1
            k=1;
            while (f(ind+k)~='(') 
                k=k+1;  
            end
            if (k-searchTermSize)>2
                occurence=occurence+1;
                search_again=1; 
            end
            %disp(k);
            %disp(search_again);
            if search_again==0
                ind=ind+k+1;
                %disp(f(ind:ind+50));
                f(1:ind-1)=[];
                %Only read a max of first 7 values because these are numbers
                data=sscanf(f,'%f,',array_size);
                %disp(data);
            else
                %break;
            end
        %% Undefined
        else
            disp(['array_type ill-defined for ',searchTerm]);
            break;
        end
    else
        disp(['No match found for ',searchTerm]);
    end
end
 

fclose(fid);