function Image = read_all_2dseq_v2(path,n_images,n_slices,data_type) % took out slice variable in here (was 4th)

% Authors Richard Foster, Robin Damion

% Opens Bruker image file 2dseq and reads one image at a time, find a max
% value from first image and scales all subsequent images for display. All
% images are returned from this function unscaled.
%
% Modified by RJF 17/10/16 from RAD's code
% assumes openning of 2dseq file 

if nargin==3 
    data_type='int16'; 
end

global rdim cdim

Image = zeros(cdim,rdim, n_images);
%Image = zeros(300,256, n_images);

% Example paty and file:
% path='X:\NMR Data\Diffusion data\Diffusion 20130514.jR1\31';
% file  ='X:\NMR Data\Diffusion data\Diffusion 20130514.jR1\31\pdata\1\2dseq';
twodseq_path='\pdata\1\2dseq';
file=strcat(path,twodseq_path);

disp('Reading raw data...')
disp(['File = ',file])

[fp,msg]=fopen(file,'r');

%color_scale=rad_greyscale(256);
color_scale=jet;


for i = 1:n_images

    %for s = 1:n_slices %took this out 17/10/16 because it conflicts with
        %multislice data
        [A,c]=fread(fp,[cdim,rdim],data_type);
        %[A,c]=fread(fp,[300,256],data_type);
        if i==1 
            amax=max(A);
            amax=max(amax);
        end
        B=A*256/amax;
        C=B';

        %if s==slice     %took this out 17/10/16 because it conflicts with
        %multislice data
            image(C);
            colormap(color_scale);
            colorbar; title(['Image ',num2str(i)]); axis image;
            Image(:,:,i)=A ;%'; % May or may not need transpose! 
        %end

        pause(0.1); % pause 0.1 second
    %end
end

fclose(fp);

